﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Windows.Forms;
using uPLibrary.Networking.M2Mqtt;
using uPLibrary.Networking.M2Mqtt.Messages;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Net;

using System.Security.Cryptography.X509Certificates;
using System.Net.Security;

namespace mqtt_expert
{
    public delegate void Event_DataChange(object sender, MqttMsgPublishEventArgs e);

    public partial class Form1 : Form
    {
        public MqttClient myClient;

        public List<TopicControl> liTopicControls = new List<TopicControl>();
        public List<string> liSubscribes = new List<string>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btn_mqtt_connect_Click(object sender, EventArgs e)
        {
            // Create Client instance
            myClient = new MqttClient(txt_brokerurl.Text);

            // Register to message received event
            myClient.MqttMsgPublishReceived += client_recievedMessage;

            string clientId = txtclientid.Text;
            string tuser = txtuser.Text;
            string tpassword = txtpassword.Text;

            myClient.Connect(clientId, tuser, tpassword);

            txt_TimestampConnect.Text = DateTime.Now.ToString();

            ti_brokerstatus.Enabled = true;

        }

        private bool AcceptAllCertifications(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
        {
            throw new NotImplementedException();
        }

        void client_recievedMessage(object sender, MqttMsgPublishEventArgs e)
        {
            // Handle message received
            var message = System.Text.Encoding.Default.GetString(e.Message);
            if (InvokeRequired)
            {
                BeginInvoke(new Event_DataChange(client_recievedMessage), new object[] { sender, e });
                return;
            }
            foreach (var TC in liTopicControls)
            {
                if(TC.Text == e.Topic)
                {
                    TC.li_Msgs.Add(e.Topic + " - " + DateTime.Now.ToString() + " - " + message + " " + e.QosLevel);
                    TC.UpdateListView();
                }
            }
            {

            }
            li_ua_result.Items.Add(e.Topic + " - " + DateTime.Now.ToString() + " - " + message + " " + e.QosLevel);

        }


        private void btn_mqtt_Disconnect_Click(object sender, EventArgs e)
        {
            myClient.Disconnect();

            base.OnClosed(e);
        }


        private void ti_brokerstatus_Tick(object sender, EventArgs e)
        {
            //@ar 24.09.2018 ausgabe auf from
            txt_clientID.Text = myClient.ClientId;
            txt_timeout.Text = myClient.Settings.TimeoutOnConnection.ToString();
            //txt_TimestampConnect.Text = DateTime.Now.ToString(); nur ausführen beim verbinden sihe connect button
            txt_ProtocolVersion.Text = myClient.ProtocolVersion.ToString();
            txt_CleanSession.Text = myClient.CleanSession.ToString();
            txt_IsConnected.Text = myClient.IsConnected.ToString();
            txt_brokerport.Text = myClient.Settings.Port.ToString();
            txt_brokerportssl.Text = myClient.Settings.SslPort.ToString();
            txt_WillFlag.Text = myClient.WillFlag.ToString();
            if (myClient.WillMessage != null) { txt_WillMessage.Text = myClient.WillMessage.ToString(); }
            txt_WillQosLevel.Text = myClient.WillQosLevel.ToString();
            if (myClient.WillTopic != null) { txt_WillTopic.Text = myClient.WillTopic.ToString(); }

            if (myClient.IsConnected)
            {
                btn_mqtt_connect.BackColor = Color.GreenYellow;
            }
            else
            {
                btn_mqtt_connect.BackColor = Color.LightPink;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //neue Form anlegen: 
            if (myClient.IsConnected)
            {
                TopicControl topicC = new TopicControl(this);
                topicC.Show();
                liTopicControls.Add(topicC);
            }
            else
            {
                MessageBox.Show("Verbinden sie sich bitte zuerst mit einem Broker, bevor sie einer Topic folgen");
            }
            
        }

    }
}
