﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Windows.Forms;
using uPLibrary.Networking.M2Mqtt;
using uPLibrary.Networking.M2Mqtt.Messages;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace mqtt_expert
{
    public partial class TopicControl : Form
    {
        MqttClient myClient;
        public string topic;
        public List<string> li_Msgs = new List<string>();
        byte QoS;
   
        public TopicControl(Form1 Parent)
        {
            InitializeComponent();
            //zuweisungen bei form start
            myClient = Parent.myClient;
            comboBox1.SelectedIndex = 2; //Qos wird auf exactly once gesetz (höchste zuverlässigkeit)
        }

        private void Bu_Publish_Click(object sender, EventArgs e)
        {
            //Nachricht auf Topic schicken
            ushort msgId = myClient.Publish(topic,Encoding.UTF8.GetBytes(TB_Data.Text), QoS, true);

            //Publish besteht aus : 1. Der Topic(srting) 2. Der Nachricht(byte[]) 3.QoS als MsgBaseQoS 4. Der Retained Info
        }

        private void Bu_Subscribe_Click(object sender, EventArgs e)
        {
            //Topic Subscriben
            ushort SubscribeID = myClient.Subscribe(new string[] { TB_Topic.Text }, new byte[] { MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE });
            topic = TB_Topic.Text;

            Bu_Subscribe.Enabled = false;
            TB_Topic.Enabled = false;

            Bu_Publish.Enabled = true;
            TB_Data.Enabled = true;

            this.Text = topic ;

        }

        public void UpdateListView()
        {
            li_ua_result.Items.Clear(); //clear list for new list input
            foreach (var msgs in li_Msgs)
            {
                li_ua_result.Items.Add(msgs);
            }

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBox1.SelectedIndex)
            {
                case (0): //at most once
                    QoS = MqttMsgBase.QOS_LEVEL_AT_MOST_ONCE;
                    break;
                case (1):  //at least once
                    QoS = MqttMsgBase.QOS_LEVEL_AT_LEAST_ONCE;
                    break;
                case (2): //exactly once
                    QoS = MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE;
                    break;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            myClient.Unsubscribe( new String[] {TB_Topic.Text} );
            button1.Enabled = false;
            Bu_Subscribe.Enabled = true;
            
        }
    }
}
